'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});

const node_1 = require('./node'); // 在这里定义node端的插件时机的名称

const serverName = [
  'sync beforeRun',
  'modifyContextAward',
  'modifyInitialPropsCtx',
  'willCache',
  'willFetch',
  'didFetch',
  'beforeCoreMiddlewares',
  'afterCoreMiddlewares'
];
const renderName = ['beforeRender', 'render', 'document', 'afterRender'];
const buildName = ['beforeBuild', 'source', 'afterBuild', 'sync babelInclude'];
const configName = ['webpackConfig', 'sync babelConfig'];
const compilerName = ['webpackCompiler'];
const names = [...serverName, ...renderName, ...buildName, ...configName, ...compilerName];
const hooks = node_1.default(names);
exports.default = {
  hooks,
  register: node_1.register,

  unregister() {
    node_1.unregister(names);
  },

  names: {
    server: serverName,
    build: buildName,
    config: configName,
    compiler: compilerName,
    render: renderName
  }
};
